/*
 * Copyright (c) 2021-2022 Akitsugu Komiyama
 * under the MIT License
 */

 /// <summary>
 /// }N֘A
 /// </summary>
class TMacro {
    // dll̒Gۃ}Ns
    using PFNEvalMacro = BOOL(WINAPI*)(const wchar_t* pwsz);
    static PFNEvalMacro Hidemaru_EvalMacro;

    using PFNGetStaticVariable = HGLOBAL(WINAPI*)(const wchar_t* pwszName, int sharedFlag);
    static PFNGetStaticVariable Hidemaru_GetStaticVariable;

    using PFNSetStaticVariable = BOOL(WINAPI*)(const wchar_t* pwszName, const wchar_t* pwszValue, int sharedFlag);
    static PFNSetStaticVariable Hidemaru_SetStaticVariable;
public:
    TMacro();
public:
    /// <summary>
    /// }Nsۂ𔻒肷
    /// </summary>
    /// <returns>sȂtrue, łȂfalse</returns>
    bool isExecuting();

public:
    /// <summary>
    /// }NvOsۂ̕Ԃl̃C^[tFCX
    /// </summary>
    class IResult {
        THmNumber result;
        THmMacroResultError error;
        std::wstring message;
    public:

        /// <summary>
        /// }NsہB
        /// </summary>
        /// <returns>}Nsꍇɂ́A1ȏAsꍇɂ0ȉ̒lB-1ȉ̂Ƃ邽0ŌߑłȂƁB</returns>
        THmNumber getResult();

        /// <summary>
        /// }Ns̎s̗OB
        /// </summary>
        /// <returns>}NssĂꍇexception^̗OĂBOȂ΁Astd::nulloptĂB</returns>
        THmMacroResultError getException();

        /// <summary>
        /// }NsʂƂẴbZ[WB\bhɂĈقȂB
        /// </summary>
        std::wstring getMessage();

        IResult(THmNumber result, THmMacroResultError error, std::wstring message);
    };

    /// <summary>
    /// ݂́u}NsvɁAvOŁA}N𕶎ŎsB
    /// <para>}Nŝݎs\ȃ\bh</para>
    /// </summary>
    /// <param name = "expression">}Ne̕</param>
    IResult doEval(std::wstring expression);

    /// <summary>
    /// Ώۂ́uGۃ}Nϐv̓ǂݍ
    /// </summary>
    /// <param name = "varname">ϐ̃V{</param>
    /// <returns>THmMacroVariable^̒lBIɂstd::get&lt;THmNumber&gt;std::get&lt;wstring&gt;Œl擾邱ƂɂȂB</returns>
    THmMacroVariable getVar(std::wstring varname);

    /// <summary>
    /// Ώۂ́uGۃ}Nϐv̓ǂݍ݁Bev[gp[^ƂČ^w肷邱ƂŃ}jAł̒l̎擾ȗłB
    /// ev[gp[^Ɏw\Ȍ^́uTHmNumberv́uwstringv̂݁B
    /// </summary>
    /// <param name = "varname">ϐ̃V{</param>
    /// <param name = "T">TɎw\Ȍ^́uTHmNumberv́uwstringv̂</param>
    /// <returns>TŎw肵^̒lBTɂ́uTHmNumberv́uwstringvlw肵Ď擾邱ƂɂȂB</returns>
    template<class T>
    T getVar(std::wstring varname) {
        THmMacroVariable v = getVar(varname);
        T r = std::get<T>(v);
        return r;
    }

    /// <summary>
    /// Ώۂ́uGۃ}Nϐvւ̏
    /// </summary>
    /// <param name = "varname">ϐ̃V{</param>
    /// <param name = "value">݂̏ꍇAl</param>
    /// <returns>̐ہBtrueAsfalse</returns>
    bool setVar(std::wstring varname, THmMacroVariable value);


    /// <summary>
    /// Ώۂ́uGۃ}N̐ÓIȕϐvւ̏ (Gۃ}Nsetstaticvariable펞s)
    /// </summary>
    /// <param name = "varname">ÓIȕϐ̃V{</param>
    /// <param name = "value">镶</param>
    /// <param name = "shared_flag">ptO</param>
    /// <returns>̐ہBtrueAsfalse</returns>
    bool setStaticVar(std::wstring varname, std::wstring value, int shared_flag);

    /// <summary>
    /// Ώۂ́uGۃ}N̐ÓIȕϐv̓ǂݍ (Gۃ}Ngetstaticvariable펞s)
    /// </summary>
    /// <param name = "varname">ÓIȕϐ̃V{</param>
    /// <param name = "shared_flag">ptO</param>
    /// <returns>Ώۂ̃L[Ɋi[ꂽ^̒lB</returns>
    std::wstring getStaticVar(std::wstring varname, int shared_flag);


    class IFunctionResult {
        THmMacroVariable result;
        THmMacroResultError error;
        std::vector<THmMacroVariable> args;
        std::wstring message;
    public:
        THmMacroVariable getResult();
        template<class T>
        T getResult() {
            THmMacroVariable v = getResult();
            T r = std::get<T>(v);
            return r;
        }
        THmMacroResultError getException();
        std::vector<THmMacroVariable> getArgs();
        std::wstring getMessage();
        IFunctionResult(THmMacroVariable result, std::vector<THmMacroVariable> args, THmMacroResultError error, std::wstring message);
    };

private:
    IFunctionResult doFunctionHelper(std::wstring func_name, std::vector<THmMacroVariable> value_args);

public:

    /// <summary>
    /// Gۃ}Ńu֐vs
    /// </summary>
    /// <param name = "func_name">֐</param>
    /// <param name = "args">}N֐ւ̉ψ</param>
    template<class... THmMacroFunctionPARAMS>
    IFunctionResult doFunction(std::wstring func_name, THmMacroFunctionPARAMS... args) {

        std::vector<THmMacroVariable> value_args;
        for (THmMacroVariable arg : std::initializer_list<THmMacroVariable>{ args... }) {
            try {
                value_args.push_back(arg);
            }
            catch (...) {
            }
        }

        return doFunctionHelper(func_name, value_args);
    }

    class IStatementResult {
        THmNumber result;
        THmMacroResultError error;
        std::vector<THmMacroVariable> args;
        std::wstring message;
    public:
        THmNumber getResult();
        THmMacroResultError getException();
        std::vector<THmMacroVariable> getArgs();
        std::wstring getMessage();
        IStatementResult(THmNumber result, std::vector<THmMacroVariable> args, THmMacroResultError error, std::wstring message);
    };


private:
    IStatementResult doStatementHelper(std::wstring statement_name, std::vector<THmMacroVariable> value_args);

public:
    /// <summary>
    /// Gۃ}N̊֐̂悤ȁuߕvs
    /// </summary>
    /// <param name = "statement_name">i֐̂悤ȁjߕ</param>
    /// <param name = "args">}Nߕւ̉ψ</param>
    template<class... THmMacroStatementPARAMS>
    IStatementResult doStatement(std::wstring statement_name, THmMacroStatementPARAMS... args) {

        std::vector<THmMacroVariable> value_args;
        for (THmMacroVariable arg : std::initializer_list<THmMacroVariable>{ args... }) {
            try {
                value_args.push_back(arg);
            }
            catch (...) {
            }
        }

        return doStatementHelper(statement_name, value_args);
    }


private:
    void setMacroVarAndMakeMacroKeyArray(const std::vector<THmMacroVariable> value_args, std::vector<std::wstring>& varname_list);
    void clearMacroVarAndUpdateArgs(const std::vector<THmMacroVariable> value_args, const std::vector<std::wstring> varname_list, std::vector<THmMacroVariable>& updated_value_args);
public:
    class TExec {
    public:
        /// <summary>
        /// u}NsĂȂvɁAvOŁAŐVȃ}NsB
        /// <para>}NsĂȂ̂ݎs\ȃ\bhB</para>
        /// </summary>
        /// <param name = "expression">}Ne̕</param>
        IResult doEval(std::wstring expression);

        /// <summary>
        /// u}NsĂȂvɁAvOŁA}Nt@C^ĐVȃ}NsB
        /// <para>}NsĂȂ̂ݎs\ȃ\bhB</para>
        /// </summary>
        /// <param name = "filepath">}Nt@C̃tpX</param>
        IResult doFile(std::wstring filepath);

        /// <summary>
        /// w̃[U[`static\bhuVȃ}NsԁvƂČĂяo
        /// </summary>
        /// <param name = "message_parameter">p[^</param>
        /// <param name = "delegate_method">Ăяo֐̓\bhuTHmNumber methodname(wstring message_parameter)̌^vɏ]\bhł邱</param>
        IResult doMethod(std::wstring message_parameter, THmMacroDoMethodType delegate_method);
    };

    /// <summary>
    /// u}NsĂȂŁA߂ă}Nsłvñ\bhQ̃NXɂBOԂ̑ցB
    /// </summary>
    TExec Exec;

public:
    /// <summary>
    /// Gۃ}Nŗp̊֐ł̂ݎgp\ȃtOlBɌEuEGrepnAăGR[hnB
    /// </summary>
    class TFlags {
    public:

        /// <summary>
        /// openfileencode
        /// </summary>
        class TEncode {
        public:
            static const int Sjis = 0x01;
            static const int Utf16 = 0x02;
            static const int Euc = 0x03;
            static const int Jis = 0x04;
            static const int Utf7 = 0x05;
            static const int Utf8 = 0x06;
            static const int Utf16_be = 0x07;
            static const int Euro = 0x08;
            static const int Gb2312 = 0x09;
            static const int Big5 = 0x0a;
            static const int Euckr = 0x0b;
            static const int Johab = 0x0c;
            static const int Easteuro = 0x0d;
            static const int Baltic = 0x0e;
            static const int Greek = 0x0f;
            static const int Russian = 0x10;
            static const int Symbol = 0x11;
            static const int Turkish = 0x12;
            static const int Hebrew = 0x13;
            static const int Arabic = 0x14;
            static const int Thai = 0x15;
            static const int Vietnamese = 0x16;
            static const int Mac = 0x17;
            static const int Oem = 0x18;
            static const int Default = 0x19;
            static const int Utf32 = 0x1b;
            static const int Utf32_be = 0x1c;
            static const int Binary = 0x1a;
            static const int LF = 0x40;
            static const int CR = 0x80;

            //SAVEAS̑̃IvV̐lw
            static const int Bom = 0x0600;
            static const int NoBom = 0x0400;
            static const int Selection = 0x2000;

            //OPENFILȆ̃IvV̐lw
            static const int NoAddHist = 0x0100;
            static const int WS = 0x0800;
            static const int WB = 0x1000;
        };

        TEncode Encode;

        class TSearchOption {
        public:
            //searchoption(֌W)
            static const int Word = 0x00000001;
            static const int Casesense = 0x00000002;
            static const int NoCasesense = 0x00000000;
            static const int Regular = 0x00000010;
            static const int NoRegular = 0x00000000;
            static const int Fuzzy = 0x00000020;
            static const int Hilight = 0x00003800;
            static const int NoHilight = 0x00002000;
            static const int LinkNext = 0x00000080;
            static const int Loop = 0x01000000;

            //searchoption(}XN֌W)
            static const int MaskComment = 0x00020000;
            static const int MaskIfdef = 0x00040000;
            static const int MaskNormal = 0x00010000;
            static const int MaskScript = 0x00080000;
            static const int MaskString = 0x00100000;
            static const int MaskTag = 0x00200000;
            static const int MaskOnly = 0x00400000;
            static const int FEnableMaskFlags = 0x00800000;

            //searchoption(u֌W)
            static const int FEnableReplace = 0x00000004;
            static const int Ask = 0x00000008;
            static const int NoClose = 0x02000000;

            //searchoption(grep֌W)
            static const int SubDir = 0x00000100;
            static const int Icon = 0x00000200;
            static const int Filelist = 0x00000040;
            static const int FullPath = 0x00000400;
            static const int OutputSingle = 0x10000000;
            static const int OutputSameTab = 0x20000000;

            //searchoption(grepĒu֌W)
            static const int BackUp = 0x04000000;
            static const int Preview = 0x08000000;

            // searchoption2gAƂtOBȂƁAint32_max𒴂Ă̂ŁAȏKvB
            static const THmNumber FEnableSearchOption2 = (THmNumber)0x80000000;

        };

        TSearchOption SearchOption;

        class TSearchOption2 {
        public:
            //searchoption2
            static const int UnMatch = 0x00000001;
            static const int InColorMarker = 0x00000002;
            static const int FGrepFormColumn = 0x00000008;
            static const int FGrepFormHitOnly = 0x00000010;
            static const int FGrepFormSortDate = 0x00000020;
        };

        TSearchOption2 SearchOption2;
    };

    TFlags Flags;
};

