/*
 * Copyright (c) 2021-2022 Akitsugu Komiyama
 * under the MIT License
 */


/// <summary>
/// t@C}l[Wg
/// </summary>
class TExplorerPane {
    static HMODULE hHmExplorerPaneDLL;

    using PFNHmExplorerPane_SetMode = int(_cdecl*)(HWND hwnd, int mode);
    static PFNHmExplorerPane_SetMode HmExplorerPane_SetMode;
    using PFNHmExplorerPane_GetMode = int(_cdecl*)(HWND hwnd);
    static PFNHmExplorerPane_GetMode HmExplorerPane_GetMode;
    using PFNHmExplorerPane_LoadProject = int(_cdecl*)(HWND hwnd, BYTE*);
    static PFNHmExplorerPane_LoadProject HmExplorerPane_LoadProject;
    using PFNHmExplorerPane_SaveProject = int(_cdecl*)(HWND hwnd, BYTE*);
    static PFNHmExplorerPane_SaveProject HmExplorerPane_SaveProject;
    using PFNHmExplorerPane_GetProject = BYTE * (_cdecl*)(HWND hwnd);
    static PFNHmExplorerPane_GetProject HmExplorerPane_GetProject;
    using PFNHmExplorerPane_GetWindowHandle = HWND(_cdecl*)(HWND hwnd);
    static PFNHmExplorerPane_GetWindowHandle HmExplorerPane_GetWindowHandle;
    using PFNHmExplorerPane_GetUpdated = int(_cdecl*)(HWND hwnd);
    static PFNHmExplorerPane_GetUpdated HmExplorerPane_GetUpdated;
    using PFNHmExplorerPane_GetCurrentDir = BYTE * (_cdecl*)(HWND hwnd);
    static PFNHmExplorerPane_GetCurrentDir HmExplorerPane_GetCurrentDir;
public:
    TExplorerPane();
public:

    /// <summary>
    /// t@C}l[Wg̃[h̐ݒ
    /// </summary>
    /// <param name = "mode">Vȃ[hl</param>
    /// <returns>sȂfalseAȂtrue</returns>
    bool setMode(int mode);

    /// <summary>
    /// t@C}l[Wg̃[h̎擾
    /// </summary>
    /// <returns>[h̒l</returns>
    int getMode();

    /// <summary>
    /// t@C}l[WgɎw̃t@C̃vWFNgǂݍ
    /// </summary>
    /// <param name = "filepath">ǂݍݑΏۂ̃vWFNg̃t@C̃tpX</param>
    /// <returns>sȂfalseAȂtrue</returns>
    bool loadProject(std::wstring filepath);

    /// <summary>
    /// t@C}l[Wg̃vWFNgwt@Cɕۑ
    /// </summary>
    /// <param name = "filepath">ۑΏۂ̃vWFNg̃t@C̃tpX</param>
    /// <returns>sȂfalseAȂtrue</returns>
    bool saveProject(std::wstring filepath);

    /// <summary>
    /// t@C}l[WgɃvWFNgǂݍłȂ΁Ãt@CpX擾
    /// </summary>
    /// <returns>t@C̃tpXBǂݍłȂ΋󕶎</returns>
    std::wstring getProject();

    /// <summary>
    /// t@C}l[WgւSendMessage
    /// <para>uR}hlvhttps://help.maruo.co.jp/hidemac/html/240_PaneDll.html</para>
    /// </summary>
    /// <param name = "command_id">R}hl</param>
    /// <returns>SendMessage̕Ԃl(LRESULT^)Ɠ</returns>
    THmNumber sendMessage(int command_id);

    /// <summary>
    /// t@C}l[WgWindowHandle
    /// </summary>
    /// <returns>t@C}l[WgWindowHandle</returns>
    HWND getWindowHandle();

    /// <summary>
    /// t@C}l[WguvWFNgv\̂ƂAXVꂽԂł邩ǂԂ܂
    /// </summary>
    /// <returns>XVԂȂ1AȊO0</returns>
    bool getUpdated();

    /// <summary>
    /// t@C}l[Wg̃JgfBNgԂ
    /// </summary>
    /// <returns>JgfBNg̃tpXBǂݑ˂ꍇ͋󕶎Ԃ܂B</returns>
    std::wstring getCurrentDir();
};
